(define-module (ui mass-management ajax)
			   :use-module (alterator ajax)
			   :use-module (alterator woo)
			   :use-module (alterator str)
			   :export (init))

(define (show-ui-new-task v)
  (form-update-visibility "new_task_div" v)
  (form-update-visibility "task_buttons_div" (not v)))

(define (ui-new-task)
  (show-ui-new-task #t)
  (catch/message
	(lambda()
	  (form-update-enum "new_task_group" (woo-list "/mass-management/avail_groups"))
	  (form-update-enum "new_task_profile" (woo-list "/mass-management/avail_profiles"))
	  (form-update-value-list (woo-read-first "/mass-management/new_task" 'language (form-value "language"))))))

(define (start-new-task)
  (catch/message
	(lambda()
	  (woo-write "/mass-management/new_task" 'new_task_number (form-value "new_task_number")
				                         'new_task_group (form-value "new_task_group")
				                         'new_task_profile (form-value "new_task_profile")
				                         'language (form-value "language"))))
  (show-ui-new-task #f)
  (list-tasks))

(define (start-task)
  (let ((current-task (form-value "tasks")))
	(catch/message
	  (lambda()
		(woo-write "/mass-management/task" 'task current-task 'language (form-value "language"))))
	(list-tasks)
	(form-update-value "tasks" current-task)
	(show-tries)))

(define (list-tasks)
  (catch/message
	(lambda()
	  (form-update-enum "tasks" (woo-list "/mass-management/tasks" 'language (form-value "language")))))
  (form-bind "tasks" "change" show-tries))

(define (show-tries)
  (show-ui-new-task #f)
  (and
	(let ((task (form-value "tasks")))
	  (catch/message
		(lambda ()
		  (form-update-enum "tries"
							(woo-list "/mass-management/tries"
									  'task task
									  'language (form-value "language")))
		  (form-update-activity "task_start_button"
								(woo-get-option (woo-read-first "/mass-management/task_can_start" 'task task)
												'can_start)))))
	(form-bind "tries" "change" show-try)))

(define (show-try)
  (form-replace "/mass-management/task-details" 'task (form-value "tasks") 'try (form-value "tries")))

(define (ui-init task try)
  (list-tasks)
  (form-update-activity "task_start_button" #f)
  (and (not-empty-string? task)
	   (not-empty-string? try)
	   (form-update-value "tasks" task)
	   (show-tries)
	   (form-update-value "tries" try)))

(define (init)
  (ui-init (form-value "task") (form-value "try"))
  (form-bind "new_task_button" "click" ui-new-task)
  (form-bind "new_task_start_button" "click" start-new-task)
  (form-bind "task_start_button" "click" start-task))
