(define-module (ui mass-management mode ajax)
			   :use-module (alterator ajax)
			   :use-module (alterator woo)
			   :use-module (alterator str)
			   :use-module (alterator effect)
			   :export (init))

(define (download-server-key)
  (form-replace "/mass-management/server-key")
  (woo-write "/mass-management/rm_tmp"))

;;; Read mode configuration
(define (read-mode)
  (catch/message
	(lambda()
	  (form-update-value-list (woo-read-first "/mass-management/mode"
						  'language (form-value "language"))))))

;;; Read mode configuration
(define (write-mode)
  (and (catch/message
	(lambda()
	  (woo-write "/mass-management/mode"
	             'mode (form-value "mode")
		     'publish_rules (form-value "publish_rules")
		     'master_server (form-value "master_server")
		     'master_group (form-value "master_group")
		     'interval (form-value "interval"))))
       (read-mode)))

(define (init)
  (read-mode)
  (effect-enable "slave_data" "mode" "slave")
  (effect-enable "master_server" "mode" "slave")
  (effect-enable "master_group" "mode" "slave")
  (effect-enable "interval" "mode" "slave")
  (init-effect)
  (form-bind "set_mode" "click" write-mode)
  (form-bind "download_server_key" "click" download-server-key))
